Subject: Re: Support NOT VALID / VALIDATE constraint options for named NOT NULL constraints

From: Álvaro Herrera <[email-masked]>
Date: Sun, 06 Apr 2025 06:56:30 +0200

Hi

I've been giving this some final polish which have me time to think it through, and I think Peter is right. We should not be adding the new column, but instead RelationBuildTupleDesc should use its existing scan of pg_constraint to determine validity status of constraints. We may need in addition a further value for attnullability that means unknown, "a constraint exists but we don't know yet if it's valid or invalid" for the times when we scanned pg_attribute but not yet pg_constraint. I think it's not too large a patch on top of that we have.

I'm going on a little excursion now but should be back to work on this in a couple of hours.